{{
''*******************************************************
''*  Tims Motor test                               V3d  *
''*  Author: Tim Meyers  aka Tapperman                  *
''*******************************************************

Revision History:
  Version  3c   - (03/02/2012) initial release
           3d   - (08/17/2012) used JoyStick instead of PC scroll bar and added
                               scale object.
}}
CON
  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000

  ' I/O Pins     
  Trg_Pin      = 16              ' trigger button on joystick
  X_Pin        = 17              ' left and right on stick position
  Y_Pin        = 18              ' up and down on stick position
  
OBJ
  Mtr     : "3_Phase_Motor_v3c"                    ' Motor ctrl by: Tim Meyers
  RC      : "RCtime"                               ' Loop driver
  Y       : "Scale"                                ' for Joy Stick

VAR
  long Pot_Y, Center
    
PUB Main | j                    '' front end control for motor
{
    Right now the motor object is hard coded on pins 10 .. 15 on the propeller.
}
  Mtr.Start                                             ' Initialize Motor (2 cogs)

  Y.Start(-1,1,99)                                      ' Setup Y as 'auto' scale

  ' I use a large time constant (around 160_000) for my stick,
  ' too low a return value will give errors in the SCALE object.
  ' I'll debug it later.
  '
  RC.Start(Y_Pin,1,@Pot_Y)                              ' read position continously

  repeat until Ina[Trg_Pin] == 0                        ' wait for calibration
    j := Y.GetScaled(Pot_Y)                             ' allow scaling
    
  waitcnt(clkfreq * 2 + cnt)                            ' wait til user lets go

  center := Y.GetScaled(Pot_Y)
  '
  ' joystick is now calibrated for use
  '
  repeat                               ' control loop
    j := 100 - Y.GetScaled(Pot_Y)                       ' my stick is reversed
    if j > (center + 2)
      Mtr.Forward((j-center) * 16)
    else
      if j < (center - 2)
        Mtr.Backward((center-j) * 16)
      else
        Mtr.MotorOff
    waitcnt(clkfreq/4 + cnt)
